//
// C++ Interface: invokeclass
//
// Description: 
//
//
// Author: Andras Mantia <amantia@kde.org>, (C) 2008
//
// Copyright: See COPYING file that comes with this distribution
//
//

#ifndef INVOKECLASS_H
#define INVOKECLASS_H

#include <tqobject.h>
#include <tqstringlist.h>

class InvokeClass : public TQObject {
Q_OBJECT
  
public:
  InvokeClass(TQObject *parent);
  void invokeSlot(TQObject *object,  const TQString& slot, TQStringList args);

  static TQStringList acceptedSlots() 
  {
    static TQStringList acceptedSlots;
    acceptedSlots  << "const TQString&";
    acceptedSlots << "const TQString&,const TQString&";
    acceptedSlots << "bool";
    acceptedSlots << "int";
    acceptedSlots << "int,int";
    acceptedSlots << "int,int,int";
    acceptedSlots << "int,int,int,int";
    acceptedSlots  << "const TQColor&";

    return acceptedSlots;    
  }

signals:
  void  invoke();
  void  invoke(const TQString&);
  void  invoke(const TQString&,const TQString&);
  void  invoke(bool);
  void  invoke(int);
  void  invoke(int,int);
  void  invoke(int,int,int);
  void  invoke(int,int,int,int);
  void  invoke(const TQColor&);

private:
  TQStringList m_acceptedSlots;

};

#endif
